import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.*;
import com.webrenderer.*;
import com.webrenderer.dom.*;

public class TestBrowser {
	
	IBrowserCanvas browser;
	JTextField textfield;
	JButton autoForm;

	public TestBrowser() {
		JFrame frame = new JFrame();	
		frame.setContentPane(content());
		frame.setSize(600, 400);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}
	public JPanel content() {
		JPanel panel = new JPanel(new BorderLayout());
		
		//Textfield for entering Google search textfield
		textfield = new JTextField(30);
		textfield.setText("Enter Text");

		autoForm = new JButton("AutoForm");
		autoForm.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e){
				// Getting a reference to the documents html form, getting reference to the elements
				String javascript = "var form=document.forms[0];"+"var elms=form.elements;" + "elms.length;";
				// Getting the number of elements from elms.length for the html form
				int num = (new Integer(browser.executeScriptWithReturn(javascript))).intValue();
				for (int i=0; i< num; i++) {
					// Loop through getting each elements name, value and type
					javascript = "elms["+i+"].name;";
					String name = browser.executeScriptWithReturn(javascript);
					javascript = "elms["+i+"].value;";
					String value = browser.executeScriptWithReturn(javascript);
					javascript = "elms["+i+"].type;";
					String type = browser.executeScriptWithReturn(javascript);
					System.out.println("For Element "+i+" the Name is: "+name+" and value is: "+value+" and type is: "+type);
					// If the type is a textfield we will set the value to WebRenderer
					String textfieldValue = textfield.getText();
					javascript = "if (elms["+i+"].type=='text')elms["+i+"].value='" + textfieldValue + "';";
					browser.executeScriptWithReturn(javascript);
				}
			}
		});
	
		//Button to activate the Google form submission
		JButton submitForm = new JButton("Submit Form");
		submitForm.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				String javascript = "form.submit()";
				//Executing the JavaScript on the browser
				browser.executeScript(javascript);
			}
		});
		
		//Must be called to stop License dialog
		BrowserFactory.setLicenseData("30dtrial", "COKK0JFAF0241K8M43CLI0NO");		

		//Core function to create browser
		browser = BrowserFactory.spawnInternetExplorer();
		browser.setJavascriptEnabled(true);

		browser.loadURL("www.google.com");

		//Laying out the Textfield and buttons in a coherent manner
		JPanel spacer = new JPanel();
		spacer.add(textfield);
		spacer.add(autoForm);
		spacer.add(submitForm);

		panel.add(BorderLayout.NORTH, spacer);
		panel.add(BorderLayout.CENTER, (Canvas)browser);
	
		return panel;
	}
	public static void main(String[] args) {
		new TestBrowser();
	}
}
